Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js	(revision 3287)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js	(working copy)
@@ -918,88 +1542,6 @@
 	return len;
 };
 
-// Applies the style found in "params" to the given element.
-TableOperations.processStyle = function(params,element) {
-	var style = element.style;
-	for (var i in params) {
-		var val = params[i];
-		switch (i) {
-		    case "f_st_backgroundColor":
-			style.backgroundColor = val;
-			break;
-		    case "f_st_color":
-			style.color = val;
-			break;
-		    case "f_st_backgroundImage":
-			if (/\S/.test(val)) {
-				style.backgroundImage = "url(" + val + ")";
-			} else {
-				style.backgroundImage = "";
-			}
-			break;
-		    case "f_st_borderWidth":
-		    	if (/\S/.test(val)) {
-				style.borderWidth = val + "px";
-			} else {
-				style.borderWidth = "";
-			}
-			if (params["f_st_borderStyle"] == "none") style.borderWidth = "0px";
-			if (params["f_st_borderStyle"] == "not set") style.borderWidth = "";
-			break;
-		    case "f_st_borderStyle":
-			style.borderStyle = (val != "not set") ? val : "";
-			break;
-		    case "f_st_borderColor":
-			style.borderColor = val;
-			break;
-		    case "f_st_borderCollapse":
-			style.borderCollapse = val ? "collapse" : "";
-			break;
-		    case "f_st_width":
-			if (/\S/.test(val)) {
-				style.width = val + params["f_st_widthUnit"];
-			} else {
-				style.width = "";
-			}
-			break;
-		    case "f_st_height":
-			if (/\S/.test(val)) {
-				style.height = val + params["f_st_heightUnit"];
-			} else {
-				style.height = "";
-			}
-			break;
-		    case "f_st_textAlign":
-			if (val == "character") {
-				var ch = params["f_st_textAlignChar"];
-				if (ch == '"') {
-					ch = '\\"';
-				}
-				style.textAlign = '"' + ch + '"';
-			} else {
-				style.textAlign = (val != "not set") ? val : "";
-			}
-			break;
-		    case "f_st_vertAlign":
-			style.verticalAlign = (val != "not set") ? val : "";
-			break;
-		    case "f_st_float":
-			if (HTMLArea.is_ie) { 
-				style.styleFloat = (val != "not set") ? val : "";
-			} else { 
-				style.cssFloat = (val != "not set") ? val : "";
-			}
-			break;
-// 		    case "f_st_margin":
-// 			style.margin = val + "px";
-// 			break;
-// 		    case "f_st_padding":
-// 			style.padding = val + "px";
-// 			break;
-		}
-	}
-};
-
 // Returns an HTML element for a widget that allows color selection.  That is,
 // a button that contains the given color, if any, and when pressed will popup
 // the sooner-or-later-to-be-rewritten select_color.html dialog allowing user
@@ -1025,27 +1567,33 @@
 	var span = doc.createElement("span");
 	span.className = "chooser";
 	span.style.backgroundColor = color;
+	var space = doc.createTextNode("\xA0");
+	span.appendChild(space);
 	button.appendChild(span);
 	button.onmouseover = function() { if (!this.disabled) this.className += " buttonColor-hilite"; };
 	button.onmouseout = function() { if (!this.disabled) this.className = "buttonColor"; };
 	span.onclick = function() {
 		if (this.parentNode.disabled) return false;
-		var typo3ColorPlugin = editor.plugins.TYPO3Color;
-		if (typo3ColorPlugin) {
-			typo3ColorPlugin.instance.dialogSelectColor("color", span, field, w);
-		} else { 
-			editor._popupDialog("select_color.html", function(color) {
-				if (color) {
-					span.style.backgroundColor = "#" + color;
-					field.value = "#" + color;
-				}
-			}, color, 200, 182, w);
+		var colorPlugin = editor.plugins.TYPO3Color;
+		if (colorPlugin) {
+			colorPlugin.instance.dialogSelectColor("color", span, field, w);
+		} else {
+			colorPlugin = editor.plugins.DefaultColor;
+			if (colorPlugin) {
+				w.insertColor = function (color) {
+					if (color) {
+						span.style.backgroundColor = color;
+						field.value = color;
+					}
+				};
+				colorPlugin.instance.onButtonPress(editor, "TableOperations");
+			}
 		}
 	};
 	var span2 = doc.createElement("span");
 	span2.innerHTML = "&#x00d7;";
 	span2.className = "nocolor";
-	span2.title = TableOperations.I18N["Unset color"];
+	span2.title = "Unset color";
 	button.appendChild(span2);
 	span2.onmouseover = function() { if (!this.parentNode.disabled) this.className += " nocolor-hilite"; };
 	span2.onmouseout = function() { if (!this.parentNode.disabled) this.className = "nocolor"; };
@@ -1055,365 +1603,179 @@
 	};
 	return df;
 };
-TableOperations.buildTitle = function(doc,i18n,content,title) {
+TableOperations.buildTitle = function(doc, content, title) {
 	var div = doc.createElement("div");
 	div.className = "title";
-	div.innerHTML = i18n[title];
+	div.innerHTML = title;
 	content.appendChild(div);
-	doc.title = i18n[title];
+	doc.title = title;
 };
-TableOperations.buildDescriptionFieldset = function(doc,el,i18n,content) {
+TableOperations.buildDescriptionFieldset = function(doc, el, content, fieldsetClass) {
 	var fieldset = doc.createElement("fieldset");
-	TableOperations.insertLegend(doc, i18n, fieldset, "Description");
+	if (fieldsetClass) fieldset.className = fieldsetClass;
+	TableOperations.insertLegend(doc, fieldset, "Description");
 	TableOperations.insertSpace(doc, fieldset);
 	var f_caption = "";
-	var capel = el.getElementsByTagName("caption")[0];
-	if (capel) f_caption = capel.innerHTML;
-	TableOperations.buildInput(doc, el, i18n, fieldset, "f_caption", "Caption:", "Description of the nature of the table", "", "", f_caption, "fr", "value", "");
+	if (el) {
+		var capel = el.getElementsByTagName("caption")[0];
+		if (capel) f_caption = capel.innerHTML;
+	}
+	TableOperations.buildInput(doc, fieldset, "f_caption", "Caption:", "Description of the nature of the table", "", "", f_caption, "fr", "value", "");
 	TableOperations.insertSpace(doc, fieldset);
-	TableOperations.buildInput(doc, el, i18n, fieldset, "f_summary", "Summary:", "Summary of the table purpose and structure", "", "", el.summary, "fr", "value", "");
+	TableOperations.buildInput(doc, fieldset, "f_summary", "Summary:", "Summary of the table purpose and structure", "", "", (el ? el.summary : ""), "fr", "value", "");
 	TableOperations.insertSpace(doc, fieldset);
 	content.appendChild(fieldset);
 };
-TableOperations.buildRowGroupFieldset = function(w,doc,editor,el,i18n,content) {
+TableOperations.buildRowGroupFieldset = function(w, doc, editor, el, content, fieldsetClass) {
 	var fieldset = doc.createElement("fieldset");
-	TableOperations.insertLegend(doc, i18n, fieldset, "Row group");
+	if (fieldsetClass) fieldset.className = fieldsetClass;
+	TableOperations.insertLegend(doc, fieldset, "Row group");
 	TableOperations.insertSpace(doc, fieldset);
-	selected = el.parentNode.tagName.toLowerCase();
-	var selectScope = TableOperations.buildSelectField(doc, el, i18n, fieldset, "f_rowgroup", "Row group:", "fr", "", "Table section", ["Table body", "Table header", "Table footer"], ["tbody", "thead", "tfoot"], new RegExp((selected ? selected : "tbody"), "i"));
 	TableOperations.insertSpace(doc, fieldset);
+	selected = el.parentNode.nodeName.toLowerCase();
+	var selectScope = TableOperations.buildSelectField(doc, fieldset, "f_rowgroup", "Row group:", "fr", "floating", "Table section", ["Table body", "Table header", "Table footer"], ["tbody", "thead", "tfoot"], new RegExp((selected ? selected : "tbody"), "i"));
+	function displayCheckbox(current, value) {
+		if (current !== "thead" && value === "thead") {
+			label1.style.display = "inline";
+			label2.style.display = "none";
+			input.style.display = "inline";
+			input.checked = true;
+		} else if (current === "thead" && value !== "thead") {
+			label1.style.display = "none";
+			label2.style.display = "inline";
+			input.style.display = "inline";
+			input.checked = true;
+		} else {
+			label1.style.display = "none";
+			label2.style.display = "none";
+			input.style.display = "none";
+			input.checked = false;
+		}
+	}
+	selectScope.onchange = function() { displayCheckbox(selected, this.value); };
+	var label1 = doc.createElement("label");
+	label1.className = "fl";
+	label1.htmlFor = "f_convertCells";
+	label1.innerHTML = "Make cells header cells";
+	label1.style.display = "none";
+	fieldset.appendChild(label1);
+	var label2 = doc.createElement("label");
+	label2.className = "fl";
+	label2.htmlFor = "f_convertCells";
+	label2.innerHTML = "Make cells data cells";
+	label2.style.display = "none";
+	fieldset.appendChild(label2);
+	var input = doc.createElement("input");
+	input.className = "checkbox";
+	input.type = "checkbox";
+	input.name = "f_convertCells";
+	input.id = "f_convertCells";
+	input.checked = false;
+	input.style.display = "none";
+	fieldset.appendChild(input);
+	TableOperations.insertSpace(doc, fieldset);
 	content.appendChild(fieldset);
 };
-TableOperations.buildCellTypeFieldset = function(w,doc,editor,el,i18n,content) {
+TableOperations.buildCellTypeFieldset = function(doc, editor, el, content, column, fieldsetClass) {
 	var fieldset = doc.createElement("fieldset");
-	TableOperations.insertLegend(doc, i18n, fieldset, "Cell Type and Scope");
+	if (fieldsetClass) fieldset.className = fieldsetClass;
+	TableOperations.insertLegend(doc, fieldset, column ? "Type of cells" : "Cell Type and Scope");
 	TableOperations.insertSpace(doc, fieldset);
 	var ul = doc.createElement("ul");
 	fieldset.appendChild(ul);
 	var li = doc.createElement("li");
 	ul.appendChild(li);
-	var selectType = TableOperations.buildSelectField(doc, el, i18n, li, "f_cell_type", "Type of cell", "fr", "", "Specifies the type of cell", ["Normal", "Header"], ["td", "th"], new RegExp(el.tagName.toLowerCase(), "i"));
-	selectType.onchange = function() { TableOperations.setStyleOptions(doc, editor, el, i18n, this); };
-	var li = doc.createElement("li");
-	ul.appendChild(li);
-	selected = el.scope.toLowerCase();
-	(selected.match(/([^\s]*)\s/)) && (selected = RegExp.$1);
-	var selectScope = TableOperations.buildSelectField(doc, el, i18n, li, "f_scope", "Scope", "fr", "", "Scope of header cell", ["Not set", "scope_row", "scope_column", "scope_rowgroup"], ["not set", "row", "col", "rowgroup"], new RegExp((selected ? selected : "not set"), "i"));
+	if (column) {
+		var selectType = TableOperations.buildSelectField(doc, li, "f_cell_type", "Type of cells of the column", "fl", "", "Specifies the type of cells", ["Data cells", "Headers for rows", "Headers for row groups"], ["td", "throw", "throwgroup"], new RegExp(el.nodeName.toLowerCase()+el.scope.toLowerCase()+"$", "i"));
+	} else {
+		var selectType = TableOperations.buildSelectField(doc, li, "f_cell_type", "Type of cell", "fr", "", "Specifies the type of cell", ["Normal", "Header for column", "Header for row", "Header for row group"], ["td", "thcol", "throw", "throwgroup"], new RegExp(el.nodeName.toLowerCase()+el.scope.toLowerCase()+"$", "i"));
+	}
+	selectType.onchange = function() { TableOperations.setStyleOptions(doc, doc.getElementById("f_class"), editor, el, this.value.substring(0,2)); };
 	TableOperations.insertSpace(doc, fieldset);
 	content.appendChild(fieldset);
 };
-TableOperations.getCssLabelsClasses = function(cssArray,i18n,tagName,selectedIn) {
-	var cssLabels = new Array();
-	var cssClasses = new Array();
-	cssLabels[0] = i18n["Default"];
-	cssClasses[0] = "none";
-	var selected = selectedIn;
-	var cls = selected.split(" ");
-	var nonReservedClassName = false;
-	for (var ia = cls.length; ia > 0;) {
-		if(!HTMLArea.reservedClassNames.test(cls[--ia])) {
-			selected = cls[ia];
-			nonReservedClassName = true;
-			break;
-		}
+TableOperations.setStyleOptions = function(doc, dropDown, editor, el, nodeName) {
+	if (!dropDown) return false;
+	if (editor.config.customSelects.BlockStyle) {
+		var blockStyle = editor.plugins.BlockStyle.instance;
+		if (!blockStyle || !blockStyle.cssLoaded) return false;
+		var classNames = blockStyle.getClassNames(el);
+		blockStyle.buildDropDownOptions(dropDown, nodeName);
+		blockStyle.setSelectedOption(dropDown, classNames, "noUnknown");
 	}
-	var found = false, i = 1, cssClass;
-	if(cssArray[tagName]) {
-		for(cssClass in cssArray[tagName]){
-			if(cssClass != "none") {
-				cssLabels[i] = cssArray[tagName][cssClass];
-				cssClasses[i] = cssClass;
-				if(cssClass == selected) found = true;
-				i++;
-			} else {
-				cssLabels[0] = cssArray[tagName][cssClass];
-			}
-		}
-	}
-	if(cssArray['all']){
-		for(cssClass in cssArray['all']){
-			cssLabels[i] = cssArray['all'][cssClass];
-			cssClasses[i] = cssClass;
-			if(cssClass == selected) found = true;
-			i++;
-		}
-	}
-	if(selected && nonReservedClassName && !found) {
-		cssLabels[i] = i18n["Undefined"];
-		cssClasses[i] = selected;
-	}
-	return [cssLabels, cssClasses, selected];
 };
-TableOperations.setStyleOptions = function(doc,editor,el,i18n,typeSelect) {
-	var tagName = typeSelect.value;
-	var select = doc.getElementById("f_class");
-	if (!select) return false;
-	var obj = dialog.editor.config.customSelects.BlockStyle ? dialog.editor.plugins.BlockStyle.instance : dialog.editor.config.customSelects["DynamicCSS-class"];
-	if (obj && (obj.loaded || obj.cssLoaded)) var cssArray = obj.cssArray;
-		else return false;
-	var cssLabelsClasses = TableOperations.getCssLabelsClasses(cssArray,i18n,tagName,el.className);
-	var options = cssLabelsClasses[0];
-	var values = cssLabelsClasses[1];
-	var selected = cssLabelsClasses[2];
-	var selectedReg = new RegExp((selected ? selected : "none"), "i");
-	while(select.options.length>0) select.options[select.length-1] = null;
-	select.selectedIndex = 0;
-	var option;
-	for (var i = 0; i < options.length; ++i) {
-		option = doc.createElement("option");
-		select.appendChild(option);
-		option.value = values[i];
-		option.appendChild(doc.createTextNode(options[i]));
-		option.selected = selectedReg.test(values[i]);
-	}
-	if(select.options.length>1) select.disabled = false;
-		else select.disabled = true;
-};
-TableOperations.buildStylingFieldset = function(doc,el,i18n,content,cssArray) {
-	var tagName = el.tagName.toLowerCase();
-	var table = (tagName == "table");
-	var cssLabelsClasses = TableOperations.getCssLabelsClasses(cssArray,i18n,tagName,el.className);
-	var cssLabels = cssLabelsClasses[0];
-	var cssClasses = cssLabelsClasses[1];
-	var selected = cssLabelsClasses[2];
+TableOperations.buildStylingFieldset = function(doc, editor, el, content, fieldsetClass) {
+	var nodeName = el ? el.nodeName.toLowerCase() : "table";
+	var table = (nodeName == "table");
 	var fieldset = doc.createElement("fieldset");
-	TableOperations.insertLegend(doc, i18n, fieldset, "CSS Style");
+	if (fieldsetClass) fieldset.className = fieldsetClass;
+	TableOperations.insertLegend(doc, fieldset, "CSS Style");
 	TableOperations.insertSpace(doc, fieldset);
 	var ul = doc.createElement("ul");
 	ul.className = "floating";
 	fieldset.appendChild(ul);
 	var li = doc.createElement("li");
 	ul.appendChild(li);
-	TableOperations.buildSelectField(doc, el, i18n, li, "f_class", (table ? "Table class:" : "Class:"), "fr", "", (table ? "Table class selector" : "Class selector"), cssLabels, cssClasses, new RegExp((selected ? selected : "none"), "i"), "", false);
-	if (table) {
+	var select = TableOperations.buildSelectField(doc, li, "f_class", (table ? "Table class:" : "Class:"), "fr", "", (table ? "Table class selector" : "Class selector"), new Array("undefined"), new Array("none"), new RegExp("none", "i"), "", false);
+	TableOperations.setStyleOptions(doc, select, editor, el, nodeName);
+	if (el && table) {
 		var tbody = el.getElementsByTagName("tbody")[0];
 		if (tbody) {
 			var li = doc.createElement("li");
 			ul.appendChild(li);
-			cssLabelsClasses = TableOperations.getCssLabelsClasses(cssArray, i18n, "tbody", tbody.className);
-			cssLabels = cssLabelsClasses[0];
-			cssClasses = cssLabelsClasses[1];
-			selected = cssLabelsClasses[2];
-			TableOperations.buildSelectField(doc, el, i18n, li, "f_class_tbody", "Table body class:", "fr", "", "Table body class selector", cssLabels, cssClasses, new RegExp((selected ? selected : "none"), "i"), "", false);
+			var select = TableOperations.buildSelectField(doc, li, "f_class_tbody", "Table body class:", "fr", "", "Table body class selector", new Array("undefined"), new Array("none"), new RegExp("none", "i"), "", false);
+			TableOperations.setStyleOptions(doc, select, editor, tbody, "tbody");
 		}
-		ul = null;
 		var thead = el.getElementsByTagName("thead")[0];
 		if (thead) {
-			var ul = doc.createElement("ul");
-			fieldset.appendChild(ul);
 			var li = doc.createElement("li");
 			ul.appendChild(li);
-			cssLabelsClasses = TableOperations.getCssLabelsClasses(cssArray, i18n, "thead", thead.className);
-			cssLabels = cssLabelsClasses[0];
-			cssClasses = cssLabelsClasses[1];
-			selected = cssLabelsClasses[2];
-			TableOperations.buildSelectField(doc, el, i18n, li, "f_class_thead", "Table header class:", "fr", "", "Table header class selector", cssLabels, cssClasses, new RegExp((selected ? selected : "none"), "i"), "", false);
+			var select = TableOperations.buildSelectField(doc, li, "f_class_thead", "Table header class:", "fr", "", "Table header class selector", new Array("undefined"), new Array("none"), new RegExp("none", "i"), "", false);
+			TableOperations.setStyleOptions(doc, select, editor, thead, "thead");
 		}
 		var tfoot = el.getElementsByTagName("tfoot")[0];
 		if (tfoot) {
-			if (!ul) {
-				var ul = doc.createElement("ul");
-				fieldset.appendChild(ul);
-			}
 			var li = doc.createElement("li");
 			ul.appendChild(li);
-			cssLabelsClasses = TableOperations.getCssLabelsClasses(cssArray, i18n, "tfoot", tfoot.className);
-			cssLabels = cssLabelsClasses[0];
-			cssClasses = cssLabelsClasses[1];
-			selected = cssLabelsClasses[2];
-			TableOperations.buildSelectField(doc, el, i18n, li, "f_class_tfoot", "Table footer class:", "fr", "", "Table footer class selector", cssLabels, cssClasses, new RegExp((selected ? selected : "none"), "i"), "", false);
+			var select = TableOperations.buildSelectField(doc, li, "f_class_tfoot", "Table footer class:", "fr", "", "Table footer class selector", new Array("undefined"), new Array("none"), new RegExp("none", "i"), "", false);
+			TableOperations.setStyleOptions(doc, select, editor, tfoot, "tfoot");
 		}
 	}
 	TableOperations.insertSpace(doc, fieldset);
 	content.appendChild(fieldset);
 };
-TableOperations.buildLayoutFieldset = function(doc,el,i18n,content,fieldsetClass) {
-	var select, selected;
+TableOperations.buildSpacingFieldset = function(doc, el, content) {
 	var fieldset = doc.createElement("fieldset");
-	if(fieldsetClass) fieldset.className = fieldsetClass;
-	TableOperations.insertLegend(doc, i18n, fieldset, "Layout");
-	var f_st_width = TableOperations.getLength(el.style.width);
-	var f_st_height = TableOperations.getLength(el.style.height);
-	var selectedWidthUnit = /%/.test(el.style.width) ? '%' : (/px/.test(el.style.width) ? 'px' : 'em');	
-	var selectedHeightUnit = /%/.test(el.style.height) ? '%' : (/px/.test(el.style.height) ? 'px' : 'em');
-	var tag = el.tagName.toLowerCase();
+	TableOperations.insertLegend(doc, fieldset, "Spacing and padding");
 	var ul = doc.createElement("ul");
 	fieldset.appendChild(ul);
-	switch(tag) {
-		case "table" :
-			var li = doc.createElement("li");
-			ul.appendChild(li);
-			TableOperations.buildInput(doc, el, i18n, li, "f_st_width", "Width:", "Table width", "", "5", f_st_width, "fr");
-			select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_widthUnit", "", "", "", "Width unit", ["percent", "pixels", "em"], ["%", "px", "em"], new RegExp((f_st_width ? selectedWidthUnit : "%"), "i"));
-			var li = doc.createElement("li");
-			ul.appendChild(li);
-			TableOperations.buildInput(doc, el, i18n, li, "f_st_height", "Height:", "Table height", "", "5", f_st_height, "fr");
-			select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_heightUnit", "", "", "", "Height unit", ["percent", "pixels", "em"], ["%", "px", "em"], new RegExp((f_st_height ? selectedHeightUnit : "%"), "i"));
-			selected = (HTMLArea._is_ie) ? el.style.styleFloat : el.style.cssFloat;
-			select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_float", "Float:", "", "", "Specifies where the table should float", ["Not set", "Non-floating", "Left", "Right"], ["not set", "none", "left", "right"], new RegExp((selected ? selected : "not set"), "i"));
-			break;
-		case "tr" :
-			var li = doc.createElement("li");
-			ul.appendChild(li);
-			TableOperations.buildInput(doc, el, i18n, li, "f_st_width", "Width:", "Row width", "", "5", f_st_width, "fr");
-			select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_widthUnit", "", "", "", "Width unit", ["percent", "pixels", "em"], ["%", "px", "em"], new RegExp((f_st_width ? selectedWidthUnit : "%"), "i"));
-			var li = doc.createElement("li");
-			ul.appendChild(li);
-			TableOperations.buildInput(doc, el, i18n, li, "f_st_height", "Height:", "Row height", "", "5", f_st_height, "fr");
-			select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_heightUnit", "", "", "", "Height unit", ["percent", "pixels", "em"], ["%", "px", "em"], new RegExp((f_st_height ? selectedHeightUnit : "%"), "i"));
-			break;
-		case "td" :
-		case "th" :
-			var li = doc.createElement("li");
-			ul.appendChild(li);
-			TableOperations.buildInput(doc, el, i18n, li, "f_st_width", "Width:", "Cell width", "", "5", f_st_width, "fr");
-			select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_widthUnit", "", "", "", "Width unit", ["percent", "pixels", "em"], ["%", "px", "em"], new RegExp((f_st_width ? selectedWidthUnit : "%"), "i"));
-			var li = doc.createElement("li");
-			ul.appendChild(li);
-			TableOperations.buildInput(doc, el, i18n, li, "f_st_height", "Height:", "Cell height", "", "5", f_st_height, "fr");
-			select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_heightUnit", "", "", "", "Height unit", ["percent", "pixels", "em"], ["%", "px", "em"], new RegExp((f_st_height ? selectedHeightUnit : "%"), "i"));		
-	}
-	content.appendChild(fieldset);
-};
-TableOperations.buildAlignmentFieldset = function(doc,el,i18n,content,fieldsetClass) {
-	var select;
-	var tag = el.tagName.toLowerCase();
-	var fieldset = doc.createElement("fieldset");
-	if(fieldsetClass) fieldset.className = fieldsetClass;
-	TableOperations.insertLegend(doc, i18n, fieldset, "Alignment");
-	var options = ["Not set", "Left", "Center", "Right", "Justify"];
-	var values = ["not set", "left", "center", "right", "justify"];
-	var selected = el.style.textAlign;
-	(selected.match(/([^\s]*)\s/)) && (selected = RegExp.$1);
-/*
-	if (tag == "td") {
-		options.push("Character");
-		values.push("character");
-		if(f_st_textAlign.charAt(0) == '"') {
-			var splitArray = f_st_textAlign.split('"');
-			var f_st_textAlignChar = splitArray[0];
-			f_st_textAlign = "character";
-		}
-	}
-*/
-	var ul = doc.createElement("ul");
-	fieldset.appendChild(ul);
 	var li = doc.createElement("li");
 	ul.appendChild(li);
-	select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_textAlign", "Text alignment:", "fl", "", "Horizontal alignment of text within cell", options, values, new RegExp((selected ? selected : "not set"), "i"));
-/*
-	if (tag == "td") {
-		var characterFields = [];
-		TableOperations.buildInput(doc, el, i18n, fieldset, "f_st_textAlignChar", "", "Align on this character", "", "1", f_st_textAlignChar, "", "floating", "", characterFields);
-		function setCharVisibility(value) {
-			for (var i = 0; i < characterFields.length; ++i) {
-				var characterFieldElement = characterFields[i];
-				characterFieldElement.style.visibility = value ? "visible" : "hidden";
-				if (value && (characterFieldElement.tagName.toLowerCase() == "input" )) {
-					characterFieldElement.focus();
-					characterFieldElement.select();
-				}
-			}
-		};
-		select.onchange = function() { setCharVisibility(this.value == "character"); };
-		setCharVisibility(select.value == "character");
-	}
-*/
+	TableOperations.buildInput(doc, li, "f_spacing", "Cell spacing:", "Space between adjacent cells", "pixels", "5", (el ? el.cellSpacing : ""), "fr", "", "postlabel");
 	var li = doc.createElement("li");
 	ul.appendChild(li);
-	selected = el.style.verticalAlign;
-	(selected.match(/([^\s]*)\s/)) && (selected = RegExp.$1);
-	select = TableOperations.buildSelectField(doc, el, i18n, li, "f_st_vertAlign", "Vertical alignment:", "fl", "", "Vertical alignment of content within cell", ["Not set", "Top", "Middle", "Bottom", "Baseline"], ["not set", "top", "middle", "bottom", "baseline"], new RegExp((selected ? selected : "not set"), "i"));
+	TableOperations.buildInput(doc, li, "f_padding", "Cell padding:", "Space between content and border in cell", "pixels", "5", (el ? el.cellPadding : ""), "fr", "", "postlabel");
 	content.appendChild(fieldset);
 };
-TableOperations.buildSpacingFieldset = function(doc,el,i18n,content) {
+TableOperations.buildColorsFieldset = function(w, doc, editor, el, content) {
 	var fieldset = doc.createElement("fieldset");
-	TableOperations.insertLegend(doc, i18n, fieldset, "Spacing and padding");
+	TableOperations.insertLegend(doc, fieldset, "Background and colors");
 	var ul = doc.createElement("ul");
 	fieldset.appendChild(ul);
 	var li = doc.createElement("li");
 	ul.appendChild(li);
-	TableOperations.buildInput(doc, el, i18n, li, "f_spacing", "Cell spacing:", "Space between adjacent cells", "pixels", "5", el.cellSpacing, "fr", "", "postlabel");
+	TableOperations.buildColorField(w, doc, editor, li, "", "FG Color:", "fr", "colorButtonNoFloat", (el ? el.style.color : ""), "color");
 	var li = doc.createElement("li");
 	ul.appendChild(li);
-	TableOperations.buildInput(doc, el, i18n, li, "f_padding", "Cell padding:", "Space between content and border in cell", "pixels", "5", el.cellPadding, "fr", "", "postlabel");
-	content.appendChild(fieldset);
-};
-TableOperations.buildBordersFieldset = function(w,doc,editor,el,i18n,content,fieldsetClass) {
-	var select;
-	var selected;
-	var borderFields = [];
-	function setBorderFieldsVisibility(value) {
-		for (var i = 0; i < borderFields.length; ++i) {
-			var borderFieldElement = borderFields[i];
-			borderFieldElement.style.visibility = value ? "hidden" : "visible";
-			if (!value && (borderFieldElement.tagName.toLowerCase() == "input")) {
-				borderFieldElement.focus();
-				borderFieldElement.select();
-			}
-		}
-	};
-	var fieldset = doc.createElement("fieldset");
-	fieldset.className = fieldsetClass;
-	TableOperations.insertLegend(doc, i18n, fieldset, "Frame and borders");
-	TableOperations.insertSpace(doc, fieldset);
-		// Gecko reports "solid solid solid solid" for "border-style: solid".
-		// That is, "top right bottom left" -- we only consider the first value.
-	selected = el.style.borderStyle;
-	(selected.match(/([^\s]*)\s/)) && (selected = RegExp.$1);
-	selectBorderStyle = TableOperations.buildSelectField(doc, el, i18n, fieldset, "f_st_borderStyle", "Border style:", "fr", "floating", "Border style", ["Not set", "No border", "Dotted", "Dashed", "Solid", "Double", "Groove", "Ridge", "Inset", "Outset"], ["not set", "none", "dotted", "dashed", "solid", "double", "groove", "ridge", "inset", "outset"], new RegExp((selected ? selected : "not set"), "i"));
-	selectBorderStyle.onchange = function() { setBorderFieldsVisibility(this.value == "none"); };
-	TableOperations.buildInput(doc, el, i18n, fieldset, "f_st_borderWidth", "Border width:", "Border width", "pixels", "5", TableOperations.getLength(el.style.borderWidth), "fr", "floating", "postlabel", borderFields);
-	TableOperations.insertSpace(doc, fieldset, borderFields);
-
-	if (el.tagName.toLowerCase() == "table") {
-		TableOperations.buildColorField(w, doc, editor, el, i18n, fieldset, "", "Color:", "fr", "colorButton", el.style.borderColor, "borderColor", borderFields);
-		var label = doc.createElement("label");
-		label.className = "fl-borderCollapse";
-		label.htmlFor = "f_st_borderCollapse";
-		label.innerHTML = i18n["Collapsed borders"];
-		fieldset.appendChild(label);
-		borderFields.push(label);
-		var input = doc.createElement("input");
-		input.className = "checkbox";
-		input.type = "checkbox";
-		input.name = "f_st_borderCollapse";
-		input.id = "f_st_borderCollapse";
-		input.defaultChecked = /collapse/i.test(el.style.borderCollapse);
-		input.checked = input.defaultChecked;
-		fieldset.appendChild(input);
-		borderFields.push(input);
-		TableOperations.insertSpace(doc, fieldset, borderFields);
-		select = TableOperations.buildSelectField(doc, el, i18n, fieldset, "f_frames", "Frames:", "fr", "floating", "Specifies which sides should have a border", ["Not set", "No sides", "The top side only", "The bottom side only", "The top and bottom sides only", "The right and left sides only", "The left-hand side only", "The right-hand side only", "All four sides"], ["not set", "void", "above", "below", "hsides", "vsides", "lhs", "rhs", "box"], new RegExp((el.frame ? el.frame : "not set"), "i"), borderFields);
-		TableOperations.insertSpace(doc, fieldset, borderFields);
-		select = TableOperations.buildSelectField(doc, el, i18n, fieldset, "f_rules", "Rules:", "fr", "floating", "Specifies where rules should be displayed", ["Not set", "No rules", "Rules will appear between rows only", "Rules will appear between columns only", "Rules will appear between all rows and columns"], ["not set", "none", "rows", "cols", "all"], new RegExp((el.rules ? el.rules : "not set"), "i"), borderFields);
-	} else {
-		TableOperations.insertSpace(doc, fieldset, borderFields);
-		TableOperations.buildColorField(w, doc, editor, el, i18n, fieldset, "", "Color:", "fr", "colorButton", el.style.borderColor, "borderColor", borderFields);
-	}
-	setBorderFieldsVisibility(selectBorderStyle.value == "none");
-	TableOperations.insertSpace(doc, fieldset);
-	content.appendChild(fieldset);
-};
-TableOperations.buildColorsFieldset = function(w,doc,editor,el,i18n,content) {
-	var fieldset = doc.createElement("fieldset");
-	TableOperations.insertLegend(doc, i18n, fieldset, "Background and colors");
-	var ul = doc.createElement("ul");
-	fieldset.appendChild(ul);
-	var li = doc.createElement("li");
-	ul.appendChild(li);
-	TableOperations.buildColorField(w, doc, editor, el, i18n, li, "", "FG Color:", "fr", "colorButtonNoFloat", el.style.color, "color");
-	var li = doc.createElement("li");
-	ul.appendChild(li);
-	TableOperations.buildColorField(w, doc, editor, el, i18n, li, "", "Background:", "fr", "colorButtonNoFloat", el.style.backgroundColor, "backgroundColor");
+	TableOperations.buildColorField(w, doc, editor, li, "", "Background:", "fr", "colorButtonNoFloat", (el ? el.style.backgroundColor : ""), "backgroundColor");
 	var url;
-	if (el.style.backgroundImage.match(/url\(\s*(.*?)\s*\)/)) url = RegExp.$1;
-	TableOperations.buildInput(doc, el, i18n, li, "f_st_backgroundImage", "Image URL:", "URL of the background image", "", "", url, "", "shorter-value");
+	if (el && el.style.backgroundImage.match(/url\(\s*(.*?)\s*\)/)) url = RegExp.$1;
+	TableOperations.buildInput(doc, li, "f_st_backgroundImage", "Image URL:", "URL of the background image", "", "", url, "", "shorter-value");
 	content.appendChild(fieldset);
 };
-TableOperations.insertLegend = function(doc,i18n, fieldset,legend) {
+TableOperations.insertLegend = function(doc, fieldset, legend) {
 	var legendNode = doc.createElement("legend");
-	legendNode.innerHTML = i18n[legend];
+	legendNode.innerHTML = legend;
 	fieldset.appendChild(legendNode);
 };
 TableOperations.insertSpace =	function(doc,fieldset,fields) {
